package cn.iocoder.yudao.module.mes.service.moldticketmanagement;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.mes.controller.admin.dashboard.vo.dashboard.EventStatisticsVO;
import cn.iocoder.yudao.module.common.controller.admin.moldticketmanagement.vo.*;
import cn.iocoder.yudao.module.common.dal.dataobject.moldrepair.MoldRepairDO;
import cn.iocoder.yudao.module.common.dal.dataobject.moldticketmanagement.MoldTicketManagementDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.module.common.dal.dataobject.moldticketresults.MoldTicketResultsDO;


/**
 * 项目方案关联 Service 接口
 *
 * @author 内蒙必硕
 */
public interface MoldTicketManagementService {

    /**
     * 创建项目方案关联
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createMoldTicketManagement(@Valid MoldTicketManagementSaveReqVO createReqVO);

    /**
     * 更新项目方案关联
     *
     * @param updateReqVO 更新信息
     */
    void updateMoldTicketManagement(@Valid MoldTicketManagementSaveReqVO updateReqVO);

    /**
     * 删除项目方案关联
     *
     * @param id 编号
     */
    void deleteMoldTicketManagement(Long id);

    /**
     * 获得项目方案关联
     *
     * @param id 编号
     * @return 项目方案关联
     */
    MoldTicketManagementDO getMoldTicketManagement(Long id);

    /**
     * 获得项目方案关联分页
     *
     * @param pageReqVO 分页查询
     * @return 项目方案关联分页
     */
    PageResult<MoldTicketManagementDO> getMoldTicketManagementPage(MoldTicketManagementPageReqVO pageReqVO);

    void batchUpdateJobStatus(@Valid MoldTicketManagementBatchUpdateReqVO reqVO);

    List<MoldTicketResultsDO> getInspectionByMoldId(Long id, String startTime, String endTime, String ids);

    List<MoldTicketResultsDO> getMaintenanceByMoldId(Long id, String startTime, String endTime, String ids);

    Long getBaoyangListCountByJobStatus();

    Long getDianjianListCountByJobStatus();

    List<MoldTicketManagementDO> getListByJobStatus();

    void selectCountMoldInspection(EventStatisticsVO eventStatisticsVO);

    void selectCountMoldMaintenance(EventStatisticsVO eventStatisticsVO);

    List<MoldTicketManagementDO> getList();
}